! Trace-by-trace integration
! Author:  Mohammad Maysami
!          SEP, Stanford University
!          May 09

program reflect

use sep 
use causint

implicit none
real,allocatable  :: data(:,:),dint(:,:)
integer           :: nz,nx,i
real              :: dx,dz
logical           :: stat,adj,add

call sep_init(SOURCE)

call from_par("adj",adj,.false.)
call from_par("add",add,.false.)

call from_history("n1",nz)
call from_history("n2",nx)
! call from_history("d1",dz)
! call from_history("d2",dx)
allocate( data(nz,nx), dint(nz,nx))
call sep_read(data)


do i=1,nx
   stat= causint_lop(adj,add,data(:,i),dint(:,i))
end do

call sep_write(dint)







call sep_close

end program
