program logtosep
! Convert ASCII log files to seplib format

  use sep
  !   res dat", int(dd/scale) &
  !   res mod", int(dm/scale) &
  !   mod", int(dx/scale) &
  !   grad", int(dg/scale)
 
  implicit none
  !   integer, dimension(:), allocatable   :: dd,dm,dx,dg,iter
  integer, dimension(:,:), allocatable :: data
  real, dimension(:), allocatable :: data1
  integer                              :: i,row,nt
  character(len=128)                   :: logfile


  call sep_init(SOURCE)
  call sep_begin_prog()

  call from_param("log",logfile)
  call from_param("row",row,1)
  nt=row*5

  allocate(data(row,5),data1(nt))
  open(UNIT=5,ACTION="read",FILE=logfile)
  do i=1,row
     read(5,"(I10,I10,I10,I10,I10)"), data(i,1),data(i,2),data(i,3),data(i,4),data(i,5) 
     !      iter(i),dd(i),dm(i),dx(i),dg(i)
  end do
  close (5)

  data1=reshape(data,(/nt/))

  ! Write out the data read from ASCII file
  call to_history("n1",row,'sepfile')
  call to_history("n2",5,'sepfile')
  call to_history("o1",0.,'sepfile')
  call to_history("o2",0.,'sepfile')
  call to_history("d1",1.,'sepfile')
  call to_history("d2",1.,'sepfile')

  call srite("sepfile",data1,4*size(data1))

  call sep_end_prog()
end program
